<script setup>
import {computed, ref} from 'vue'
import {useLessonStore} from "@/stores/lesson"
import {useTrainerStore} from "@/stores/trainer";
import {useGroupStore} from "@/stores/group";
import {useRoomStore} from "@/stores/room";
import {useEnumStore} from "@/stores/enumStore";

const lessonStore = useLessonStore()
const trainerId = ref()
const groupId = ref()
const subjects = ref()
const room = computed(() => roomStore.rooms.find(room => room.groupId === groupId.value))
const weekday = ref([])
const apiError = ref("")

const subjectList = computed(() => enumStore.subjects.filter(subject => trainerStore.trainers.find(trainer => trainer.id === trainerId.value)?.subjects.includes(subject)))

const groupStore = useGroupStore()
const roomStore = useRoomStore()
const trainerStore = useTrainerStore()
const enumStore = useEnumStore()

async function createLesson() {
  apiError.value = ""
  try {
    await lessonStore.createLesson({
      trainerId: trainerId.value,
      groupId: groupId.value,
      subjects: subjects.value,
      roomId: room.value,
      weekday: weekday.value

    })
  } catch (err) {
    if (err.isAxiosError && err.status === 401) {
      apiError.value = "You must be logged in"
    } else {
      apiError.value = "Unknown error"
    }
  }

  trainerId.value = null
  groupId.value = null
  subjects.value = null
  room.value = null
  weekday.value = []
}
</script>

<template>
  <div class="bg-black text-white rounded-2 p-3">
    <form @submit.prevent="createLesson">
      <div class="mb-3 row">
        <label class="col-12 col-md-6">
          <span class="form-label">Trainer</span>
          <select class="form-select" name="trainerId" v-model="trainerId" required>
            <option v-for="trainer in trainerStore.trainers" :value="trainer.id">{{ trainer.firstName }}
              {{ trainer.lastName }}
            </option>
          </select>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Group</span>
          <select class="form-select" name="groupId" v-model="groupId" required>
            <option v-for="group in groupStore.groups" :value="group.groupId">{{ group.specializations }}
              {{ group.groupNumber }}
            </option>
          </select>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Subject</span>
          <select class="form-select" name="subject" v-model="subjects" required>
            <option v-for="subj in subjectList">{{ subj }}</option>
          </select>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Room</span>
          <div class="room text-warning" v-if="room">{{ room.roomNumber }} {{ room.vip }}</div>

        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Weekday</span>
          <select class="form-select" name="day" v-model="weekday" required>
            <option v-for="day in enumStore.weekdays">{{ day }}</option>
          </select>
        </label>
      </div>
      <button type="submit" class="btn btn-warning">Add Lesson</button>
    </form>
  </div>
</template>

<style scoped>
.bg-black {
  width: 1000px;
}

.room {

  margin-top: 6px;
}
</style>